# Top Description

The "Description" / "Help text" on a form field can sometimes be lost when it's displayed at the bottom of the element, particularly on a WYSIWYG text area. See these posts:

- https://drupal.org/node/645754
- https://drupal.org/node/1600944
- https://groups.drupal.org/node/206593

This module just moves the "Description" / "Help text" on form elements to the top, under the label.

## Installation

Install and enable Top Description as you would any other contributed module. See

https://www.drupal.org/docs/extending-drupal/installing-modules

Once enabled, it should move the "Description" / "Help text" to the top on all fields except for radios and checkboxes (it looks strange at the top on those).

This will only work for modern (D8+) themes that support a setting like `$variables['description_display'] = 'before'`. Claro, Olivero, and many other themes support this.

If this module does not work, it is most-likely because the theme being used does not support that setting. You might consider contacting the theme maintainer.

## Implementation for `text_format` fields

Simply setting `$variables['description_display'] = 'before'` will not work on `text_format` fields. See the issue here:

[Text format wrapper does not honor description_display](https://www.drupal.org/project/drupal/issues/2421445)

This module includes a custom implementation of the `Drupal\filter\Element\TextFormat` plugin that includes the important part of the patch in [#19](https://www.drupal.org/project/drupal/issues/2421445#comment-14328646) from that issue.

Once that issue is resolved, that plugin can be removed along with the implementation of `hook_element_plugin_alter()` from the `top_description.module` file.
